Draft PathArray/cs: Difference between revisions

From FreeCAD Documentation
(Created page with "Kreslení TrasovéPole")
 
(Updating to match new version of source page)
(37 intermediate revisions by 3 users not shown)
Line 1: Line 1:
<languages/>
{{GuiCommand|Name=Draft_PathArray|Workbenches=[[Draft Module|Draft]], [[Arch Module|Arch]]|MenuLocation=Draft -> PathArray|SeeAlso=[[Draft Array]] }}
{{Docnav|[[Draft_LinkArray|Link Array]]|[[Draft_PathLinkArray|Path LinkArray]]|[[Draft_Module|Draft]]|IconL=Draft_LinkArray.svg|IconC=Workbench_Draft.svg|IconR=Draft_PathLinkArray.svg}}


<div class="mw-translate-fuzzy">
==Description==
{{GuiCommand/cs|Name=Draft PathArray|Name/cs=Kreslení TrasovéPole|Workbenches=[[Draft Module/cs|Kreslení]], [[Arch Module/cs|Architektura]]|MenuLocation=Draft → PathArray|SeeAlso=[[Draft Array/cs|Draft Array]] }}
</div>


==Popis==
The PathArray tool places copies of a selected shape along a selected path. The path can be a Wire or one or more Edges. The shapes can optionally be aligned with the tangent of the path. If required, a translation Vector can be specified to shift the shapes so the centroid is on the path. If no objects are selected, you will be invited to select them.

<div class="mw-translate-fuzzy">
Nástroj TrasovéPole umístí vybraný tvar na vybranou trasu. Trasa může být drát nebo jedna nebo více hran. Tvary na trase mohou být volitelně zarovnány podle trasy. Podle potřeby může být specifikován Vektor pro posunutí tvaru tak, že těžiště tvaru bude na trase. Pokud není vybrán žádný objekt, budete vyzváni k jeho výběru.
</div>

The PathArray tool can be used on 2D shapes created with the [[Draft Workbench]], but can also be used on many types of 3D objects such as those created with the [[Part Workbench|Part]], [[PartDesign Workbench|PartDesign]], or [[Arch Workbench|Arch Workbench]]es.

To position copies in an orthogonal array use [[Draft Array|Draft Array]]; to position copies at specified points use [[Draft PointArray|Draft PointArray]]; to create copies or clones, and manually place them use [[Draft Move|Draft Move]], [[Draft Rotate|Draft Rotate]], and [[Draft Clone|Draft Clone]].


[[Image:Draft_PathArray_Example.png|400px]]
[[Image:Draft_PathArray_Example.png|400px]]
{{Caption|Object arranged along a path}}


<div class="mw-translate-fuzzy">
==How to use==
==Použití==
</div>


<div class="mw-translate-fuzzy">
# Select a shape object you wish to distribute.
# Vyberte objekt tvaru, který chcete kopírovat.
# Select a path object along which the shapes will be distributed. -or-
# Vyberte objekt trasy, po které chcete tvar kopírovat -nebo-
# Select some edges of a path object.
# Vyberte nějaké hrany pro určení trasy.
# Press the {{KEY|[[Image:Draft_PathArray.png|16px]] [[Draft PathArray]]}} button.
# Stiskněte tlačítko {{KEY|[[Image:Draft_PathArray.png|16px]] [[Draft PathArray/cs|Kreslení TrasovéPole]]}}.
</div>


Each element in the array is an exact clone of the original object, but the entire array is considered a single unit in terms of properties and appearance.
==Options==


The base object should be centred around the origin, even if the path starts somewhere else.
* The array starts with shape copies which are not aligned to the path, nor translated to a new position by default. You can then change the count, alignment and/or translation vector in the properties.


==Properties==
==Volby==


<div class="mw-translate-fuzzy">
* {{PropertyData|Base}}: The shape object
* Pole začne s kopiemi tvaru, které nejsou zarovnány podle trasy ani defaultně posunuty na novou pozici. Ve vlastnostech můžete měnit počet, zarovnání a/nebo vektor posunutí.
* {{PropertyData|PathObj}}: The path object
</div>
* {{PropertyData|PathSubs}}: The subelements(edges) of path object to be used as the path
* {{PropertyData|Count}}: The number of time to copy the shape
* {{PropertyData|Xlate}}: The translation vector
* {{PropertyData|Align}}: True to align the shapes to the path, False to leave shapes in their default orientation.


==Scripting==
==Vlastnosti==


<div class="mw-translate-fuzzy">
The PathArray tool can by used in [[macros]] and from the python console by using the following function:
* {{PropertyData|Base}}: Objekt tvaru
* {{PropertyData|PathObj}}: Objekt trasy
* {{PropertyData|PathSubs}}: Subelementy(hrany) objektu trasy, které budou použity jako trasa
* {{PropertyData|Count}}: Počet kopií tvaru
* {{PropertyData|Xlate}}: Vektor posunutí
* {{PropertyData|Align}}: Hodnota True pro zarovnání tvarů podle trasy, False pro ponechání tvarů podle jejich původní orientace.
</div>


<div class="mw-translate-fuzzy">
<syntaxhighlight>
==Skriptování==
makePathArray(shapeobject,pathobject,count,[translationvector],[alignment],[listofpathsubelements])
</div>
</syntaxhighlight>
* Distribute count copies of a document shapeobject along a pathobject or subobjects of a pathobject. Optionally translates each copy by FreeCAD.Vector xlate direction and distance to adjust for difference in shape centre vs shape reference point. Optionally aligns baseobject to tangent/normal/binormal of path.


<div class="mw-translate-fuzzy">
Example:
Nástroj TrasovéPole může být využit v [[macros|makrech]] a z konzoly Pythonu použitím následující funkce:
<syntaxhighlight>
</div>
import FreeCAD,Draft
{{Code|code=
Draft.makePathArray(base,path,items,centretrans,orient,pathsubs)
PathArray = makePathArray(baseobject, pathobject, count, xlate=None, align=False, pathobjsubs=[])
</syntaxhighlight>
}}


<div class="mw-translate-fuzzy">
==Limitations==
* Rozloží požadovaný počet (count) kopií objektu shapeobject podél trasy pathobject nebo subobject (vybrané hrany) pathobjectu. Volitelně posune každou kopii ve směru a vzdálenosti podle FreeCAD.Vectoru pro nastavení rozdílu mezi středem tvaru a referenčním bodem tvaru. Volitelně zarovná baseobject tangenciálně/normálně/binormálně k trase.
* This tool is not available before version 0.14
</div>
* The PathSubs Property does not yet appear in the properties list.


Příklad:
<languages/>
{{Code|code=
import FreeCAD,Draft

p1 = FreeCAD.Vector(500, -1000, 0)
p2 = FreeCAD.Vector(1500, 1000, 0)
p3 = FreeCAD.Vector(3000, 500, 0)
p4 = FreeCAD.Vector(4500, 100, 0)
spline = Draft.makeBSpline([p1, p2, p3, p4])
object = Draft.makePolygon(3, 500)

PathArray = Draft.makePathArray(object, spline, 6)
}}

==Technical explanation for the Align property==
When {{PropertyData|Align}} is {{FALSE}}, the placement of the copied shapes is easy to understand; they are just moved to a different position in their original orientation.
[[Image:patharray_NoAlign.png|600px|left|Align false]]
{{clear}}
{{Caption|Object arranged along a closed path in the original orientation}}

When {{PropertyData|Align}} is {{TRUE}}, the positioning of the shapes becomes a bit more complex:
# First, Frenet coordinate systems are built on the path: X is tangent, Z is normal, Y is binormal.
# Then the original object is copied to every on-path coordinate system, so that the global origin is matched with the on-path coordinate system origin.
[[Image:patharray alignment annotated.png|600px|left]]
{{clear}}
{{Caption|Object arranged along a closed path; description of components and path}}

The following images show how the array is produced, depending on which plane the path is.

Path on XY Plane:
[[Image:patharray_alignment.png|600px|left]]
{{clear}}
{{Caption|Object arranged along a closed path which is aligned to the XY plane}}

Path on XZ Plane:
[[Image:patharray_alignment-XZ.png|600px|left]]
{{clear}}
{{Caption|Object arranged along a closed path which is aligned to the XZ plane}}

Path on YZ Plane:
[[Image:patharray_alignment-YZ.png|600px|left]]
{{clear}}
{{Caption|Object arranged along a closed path which is aligned to the YZ plane}}

As you reorient the path but not the object, the result is consistent: the object remains aligned to the path the way it was before reorienting the path.

{{Emphasis|Editor:}} thank you to user DeepSOIC for this explanation.

{{Docnav|[[Draft_LinkArray|Link Array]]|[[Draft_PathLinkArray|Path LinkArray]]|[[Draft_Module|Draft]]|IconL=Draft_LinkArray.svg|IconC=Workbench_Draft.svg|IconR=Draft_PathLinkArray.svg}}

{{Draft Tools navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}
{{clear}}

Revision as of 20:36, 21 February 2020

Kreslení TrasovéPole

Umístění Menu
Draft → PathArray
Pracovní stoly
Kreslení, Architektura
Výchozí zástupce
Nikdo
Představen ve verzi
-
Viz také
Draft Array

Popis

Nástroj TrasovéPole umístí vybraný tvar na vybranou trasu. Trasa může být drát nebo jedna nebo více hran. Tvary na trase mohou být volitelně zarovnány podle trasy. Podle potřeby může být specifikován Vektor pro posunutí tvaru tak, že těžiště tvaru bude na trase. Pokud není vybrán žádný objekt, budete vyzváni k jeho výběru.

The PathArray tool can be used on 2D shapes created with the Draft Workbench, but can also be used on many types of 3D objects such as those created with the Part, PartDesign, or Arch Workbenches.

To position copies in an orthogonal array use Draft Array; to position copies at specified points use Draft PointArray; to create copies or clones, and manually place them use Draft Move, Draft Rotate, and Draft Clone.

Object arranged along a path

Použití

  1. Vyberte objekt tvaru, který chcete kopírovat.
  2. Vyberte objekt trasy, po které chcete tvar kopírovat -nebo-
  3. Vyberte nějaké hrany pro určení trasy.
  4. Stiskněte tlačítko Kreslení TrasovéPole.

Each element in the array is an exact clone of the original object, but the entire array is considered a single unit in terms of properties and appearance.

The base object should be centred around the origin, even if the path starts somewhere else.

Volby

  • Pole začne s kopiemi tvaru, které nejsou zarovnány podle trasy ani defaultně posunuty na novou pozici. Ve vlastnostech můžete měnit počet, zarovnání a/nebo vektor posunutí.

Vlastnosti

  • ÚdajeBase: Objekt tvaru
  • ÚdajePathObj: Objekt trasy
  • ÚdajePathSubs: Subelementy(hrany) objektu trasy, které budou použity jako trasa
  • ÚdajeCount: Počet kopií tvaru
  • ÚdajeXlate: Vektor posunutí
  • ÚdajeAlign: Hodnota True pro zarovnání tvarů podle trasy, False pro ponechání tvarů podle jejich původní orientace.

Skriptování

Nástroj TrasovéPole může být využit v makrech a z konzoly Pythonu použitím následující funkce:

PathArray = makePathArray(baseobject, pathobject, count, xlate=None, align=False, pathobjsubs=[])
  • Rozloží požadovaný počet (count) kopií objektu shapeobject podél trasy pathobject nebo subobject (vybrané hrany) pathobjectu. Volitelně posune každou kopii ve směru a vzdálenosti podle FreeCAD.Vectoru pro nastavení rozdílu mezi středem tvaru a referenčním bodem tvaru. Volitelně zarovná baseobject tangenciálně/normálně/binormálně k trase.

Příklad:

import FreeCAD,Draft

p1 = FreeCAD.Vector(500, -1000, 0)
p2 = FreeCAD.Vector(1500, 1000, 0)
p3 = FreeCAD.Vector(3000, 500, 0)
p4 = FreeCAD.Vector(4500, 100, 0)
spline = Draft.makeBSpline([p1, p2, p3, p4])
object = Draft.makePolygon(3, 500)

PathArray = Draft.makePathArray(object, spline, 6)

Technical explanation for the Align property

When ÚdajeAlign is false, the placement of the copied shapes is easy to understand; they are just moved to a different position in their original orientation.

Align false
Align false

Object arranged along a closed path in the original orientation

When ÚdajeAlign is true, the positioning of the shapes becomes a bit more complex:

  1. First, Frenet coordinate systems are built on the path: X is tangent, Z is normal, Y is binormal.
  2. Then the original object is copied to every on-path coordinate system, so that the global origin is matched with the on-path coordinate system origin.

Object arranged along a closed path; description of components and path

The following images show how the array is produced, depending on which plane the path is.

Path on XY Plane:

Object arranged along a closed path which is aligned to the XY plane

Path on XZ Plane:

Object arranged along a closed path which is aligned to the XZ plane

Path on YZ Plane:

Object arranged along a closed path which is aligned to the YZ plane

As you reorient the path but not the object, the result is consistent: the object remains aligned to the path the way it was before reorienting the path.

Editor: thank you to user DeepSOIC for this explanation.